@ManagedBean(name = "profileBean")
@ViewScoped
public class ProfileBean extends GenericViewBean {

	
	public String save() {
		pageAction = RiskConstants.CREATE;
		List<ErrorMessage> messages = new ArrayList<ErrorMessage>();
		messages = Util.compareDates(profileDTO.getValidDateFrom(),
				profileDTO.getValidDateTo(),
				RiskConstants.ERROR_VALID_DATE_FROM,
				RiskConstants.ERROR_VALID_DATE_TO);

		if (messages.size() > 0) {
			addErrorMessages(messages);
			getFlash().put("profileBean", this);
			return RiskConstants.DUPLICATE_DETAILS;
		}

		if (!Util.isNullOrEmpty(getRecurrenceDTO().getStartOn())
				&& (!Util.isNullOrEmpty(getRecurrenceDTO().getEndOn()))) {
			int start = Integer.parseInt(getRecurrenceDTO().getStartOn());
			int end = Integer.parseInt(getRecurrenceDTO().getEndOn());
			if (start > end) {
				if (showMonthly) {
					messages.add(new ErrorMessage(
							RiskConstants.ERROR_MONTH_GREATER, new String[] {
									RiskConstants.STARTDATE,
									RiskConstants.TODATE }));
				} else if (showWeekly) {
					messages.add(new ErrorMessage(
							RiskConstants.ERROR_MONTH_GREATER,
							new String[] { RiskConstants.STARTDAY,
									RiskConstants.TODAY }));
				}
			}
			if (messages.size() > 0) {
				addModuleErrorMessages(messages);
				getFlash().put("profileBean", this);
				return "";
			}
		}
		addDetails(profileDTO);
		String userDetails = null;
		if (getCMSUser() != null) {
			userDetails = getCMSUser().getUserName();
		}

		if (!profileDTO.getSelected()) {
			boolean isExist = false;
			try {
				isExist = profileManager.isExist(profileDTO.getProfileCode());
				if (isExist) {
					messages.add(new ErrorMessage(
							RiskConstants.ERROR_PROFILE_DUPLICATE,
							new String[] { profileDTO.getProfileCode() }));
					getFlash().put("profileBean", this);
				} else {
					boolean status = false;
					if (profileDTO.getProfileId() == null) {
						for (int i = 0; i < getProfileCrtList().size(); i++) {
							getProfileCrtList().get(i).setLineNo(i);
						}
						profileDTO.setCreatedBy(userDetails);
						profileDTO.setCreatedDate(new Date());
						status = profileManager.createProfile(profileDTO);
						if (status) {
							showConfirmBox = true;
							// Added by Siva to show the confirm message --
							// Start
							if (!Util.isNullOrEmpty(getActiveTab())) {
								if (tab.equals(
										RiskConstants.MAIN_TAB)) {
									setActiveTab(RiskConstants.MAIN_TAB);
								}
								if (tab.equals(
										RiskConstants.DETAILS_TAB)) {
									setActiveTab(RiskConstants.DETAILS_TAB);
								}
								if (tab.equals(
										RiskConstants.RECURRENCE_TAB)) {
									setActiveTab(RiskConstants.RECURRENCE_TAB);
								}
								if (tab.equals(
										RiskConstants.NOTIFICATION_TAB)) {
									setActiveTab(RiskConstants.NOTIFICATION_TAB);
								}
							}
							// Added by Siva to show the confirm message -- End
							getFlash().put("profileBean", this);
							auditManager.insert(new AuditTrailDTO(
									RiskConstants.RSK,
									RiskConstants.PROFILECREATE, profileDTO
											.getProfileCode(), userDetails,
									new Date(), null, null));
						}
						profileDTO.setSelected(true);
					}
				}
			} catch (ManagerException e) {
				e.printStackTrace();
				customsLog.error(e.getMessage(), e);
			}
		} else {
			try {

				for (int i = 0; i < getProfileCrtList().size(); i++) {
					getProfileCrtList().get(i).setLineNo(i);
				}
				boolean status = false;
				profileDTO.setCreatedBy(userDetails);
				profileDTO.setCreatedDate(new Date());
				status = profileManager.update(profileDTO);
				if (status) {
					showConfirmBox = true;
					// Added by Siva to show the confirm message -- Start
					if (tab.equals(RiskConstants.MAIN_TAB)) {
						activeTab = tab;
					} else if (tab.equals(RiskConstants.DETAILS_TAB)) {
						activeTab = tab;
					}

					else if (tab.equals(RiskConstants.RECURRENCE_TAB)) {
						activeTab = tab;

					} else if (tab.equals(RiskConstants.NOTIFICATION_TAB)) {
						activeTab = tab;
					}
					// Added by Siva to show the confirm message -- End
					getFlash().put("profile_bean_flash_param", "saveProfile");
					getFlash().put("profileBean", this);
					auditManager.insert(new AuditTrailDTO(RiskConstants.RSK,
							RiskConstants.PROFILEUPDATE, profileDTO
									.getProfileCode(), userDetails, new Date(),
							null, null));
				}
			} catch (ManagerException e) {
				customsLog.error(e.getMessage(), e);
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (messages.size() > 0) {
			addModuleErrorMessages(messages);
			tab = RiskConstants.MAIN_TAB;
			if (tab.equals(RiskConstants.MAIN_TAB)) {
				activeTab = tab;
			} else if (tab.equals(RiskConstants.DETAILS_TAB)) {
				activeTab = tab;
			}

			else if (tab.equals(RiskConstants.RECURRENCE_TAB)) {
				activeTab = tab;

			} else if (tab.equals(RiskConstants.NOTIFICATION_TAB)) {
				activeTab = tab;
			}
			return RiskConstants.DUPLICATE_DETAILS;
		} else {
			showProfileDetails = true;
			showProfileNotification = false;
			showProfileRecurrence = true;
			if (tab.equals(RiskConstants.MAIN_TAB)) {
				activeTab = tab;
			} else if (tab.equals(RiskConstants.DETAILS_TAB)) {
				activeTab = tab;
			} else if (tab.equals(RiskConstants.RECURRENCE_TAB)) {
				activeTab = tab;
			} else if (tab.equals(RiskConstants.NOTIFICATION_TAB)) {
				activeTab = tab;
			}
			return "";
		}
	}	
}